﻿SessionData = new SessionDB();
SessionData.restore(); //Restore any old session data

function UpdateStatsUI () {
    $("#loading").remove();
    $("#loadingtext").hide();

    var safe_hours = SessionData.getHours();
    if(safe_hours < 48) {
        $("#hours-left").text( fractionHours( safe_hours ) );
        $("#container").show();
        $("#displaywarning").hide();
    } else {
        $("#displaywarning").show();
        $("#container").hide();
    }
}

function BuildUI() {
    $("#displaywarning").hide();
    $("#container").hide();
    $("#loadingtext").show();
    var DrinksList = $("#drinks_list");
    DrinksList.empty();

    for(var index = 0; index < DrinksDataBase.length; index++)
    {

        var section = GetDrinkSection(index);
        DrinksList.append("<div data-role='collapsible' data-iconpos='right' id='drink-section-"+index+"'> </div>");
        var colsechtml = $("#drink-section-"+index);

        colsechtml.append("<h4 class='ui-grad-teal'><img class='headerdrinkimage' src='" + section.headerimage + "' /><img class='headerdrinktext' src='" + section.headertext + "' /></h4>");
        colsechtml.append("<ul data-role='listview' id='section-"+ index +"' class='ui-drink-ul'> </ul>");
        var sechtml = $("#section-"+index);
        //sechtml.append("<br />") Add a blank li at start of section to give us some spacing.

        for(var dindex = 0; dindex < section.drinks.length; dindex++) {
            var drink = GetDrink(index, dindex);
            console.log("building index: "+ index + " dindex: " + dindex);




            sechtml.append("<li class='ui-drink-li'>"
                    +"<div class='ui-drink-name'><strong>" + drink.name + " " + drink.volume + "</strong><br />" + drink.example + "</div>" +
                    "<div class='ui-drink-spinner'><input type='text' align='right' data-mini='true' data-role='spinbox' name='spin' data-section-index='"+index+"' data-drink-index='"+dindex+"'" +
                    "id='spin-"+index+"-"+dindex+"' value='"+SessionData.getDrunk(index, dindex)+"' min='0' max='100' /></div>"
                    + "</li>");

            var Ref = $("#spin-"+index+"-"+dindex);
            if(Ref == undefined)
                throw "Huh?!";

            $("#spin-"+index+"-"+dindex).change(function() {
                var value = $(this).val();
                var index_s = $(this).data("section-index");
                var index_d = $(this).data("drink-index");
                console.log("Called change with: " + index_s + " : " + index_d + " val: " + value);
                SessionData.setDrunk(index_s, index_d, value);

                UpdateStatsUI();
            });
        }

        //sechtml.append("<br />") Add a blank li at end of section to give us some spacing.

        $("#main").trigger("create");
        DrinksList.collapsibleset("refresh");
    }

    //ReadOnly
        for(var index = 0; index < DrinksDataBase.length; index++)
        {

            var section = GetDrinkSection(index);
            for(var dindex = 0; dindex < section.drinks.length; dindex++) {
                var Ref = $("#spin-"+index+"-"+dindex);
                Ref.prop('readonly', true);
                console.log("read only set for: " + "#spin-"+index+"-"+dindex);
            }
        }

    UpdateStatsUI();
}

function fractionHours(units) {
    // This function will round a number up to the next 1/4.
    // It assumes that the input number is specified to the nearest 0.05 (eg 1.00, 1.05, 1.10, 1.15, etc).
    // It allows rounding errors in the storage of FP numbers as large as 0.01, so 1.00999 returns as 1, not 1-and-a-quarter.
    // See examples in spreadsheet doc/Rounding by quarters, accommodating float imprecision.xlsx

    var adjUnits = units + 0.24;
    var numerator = Math.floor( ( adjUnits % 1 ) * 4);
    switch (numerator )
    {
        case 0:
            var displayFraction = "";
            break;
        case 1:
            displayFraction = "\xBC";   /*   1/4   */
            break;
        case 2:
            displayFraction = "\xBD";   /*   1/2   */
            break;
        case 3:
            displayFraction = "\xBE";   /*   3/4   */
            break;
        default:
            displayFraction = ("error numerator: " + numerator).toString();
            break;

    }

    return (Math.floor( adjUnits ) + displayFraction).toString()
}

function fast_reset() {
        SessionData.reset();
        UpdateStatsUI();
        for(var index = 0; index < DrinksDataBase.length; index++)
        {

        var section = GetDrinkSection(index);
            for(var dindex = 0; dindex < section.drinks.length; dindex++) {
                var Ref = $("#spin-"+index+"-"+dindex).val("");
            }
        }
}

$(function() {
    BuildUI();
});
