function SessionDB() {
  this.currentDrinks = {};
  this.reset = function() {
    this.currentDrinks = {};
    this.persist();
  }

  this.units_consumed = function() {
    var total = 0;
    for (var k in this.currentDrinks){
        if (this.currentDrinks.hasOwnProperty(k))
        {
             var v = this.currentDrinks[k];
             v = Math.max(0, v); // Dont let this go Below 0..

             var parts = k.split("-");
             if(!parts.length == 2)
                continue;

             var drink = GetDrink(parts[0], parts[1]);
             total += Math.round( (drink.units * v) * 10 ) / 10;
        }
    }

    return Math.round(total * 10) / 10;
  }

  this.getHours = function() {
      var unitsConsumed = this.units_consumed();
      return unitsConsumed == 0 ? 0 : ( ( Math.ceil(2 * unitsConsumed) ) / 2 ) + 1;
    //Always add an hour unless we are at 0 (don't want to display an hour with out drinking)
  }

  this.setDrunk = function(index, dindex, value) {
        this.currentDrinks[index + "-" + dindex] = value;
        this.persist();
  }

  this.getDrunk = function(index, dindex) {
        console.log("getDrunk: ", index, dindex, this.currentDrinks[index + "-" + dindex])
        if(this.currentDrinks[index + "-" + dindex] == undefined)
            return 0;
        else
            return this.currentDrinks[index + "-" + dindex];
  }

  this.persist = function() {
    var Data = {
      currentUnitsConsumed: this.currentUnitsConsumed,
      currentDrinks: this.currentDrinks
    };

    localforage.setItem("sessionDB-data", JSON.stringify(Data), function(err, value) {
      console.log("Persisted Drinking Session with: " + JSON.parse(value).currentDrinks.length + " drinks in the list"); //DEBUG: I know this is a waste of cpu. (encoding / decoding. but it does verify the save completed during debug)
    });
  }

  this.on_session_restore = function(err, value) {
    if (err) {
      throw err;
    } else {
      if (value == undefined)
        return // use defaults as no previous save data
        else {
            var Data = JSON.parse(value);

            this.currentUnitsConsumed = Data.currentUnitsConsumed;
            this.currentDrinks = Data.currentDrinks;
            console.log("Loaded Drinking Session with: " + this.currentDrinks.length + " drinks in the list");
        }
      }

      BuildUI();
    }

  this.restore = function() {
    localforage.getItem("sessionDB-data", this.on_session_restore.bind(this)); //Had to do it this way so the "this" context was correct and pointed to SessionDB not an anon context - Remind me to explain this better in person
  }
}


/*
  USAGE:
  var SessionData = new SessionDB();


*/
